/*
 * $Id: BarrageButton.as,v 1.1.1.1 2006/07/17 03:27:32 kenta Exp $
 *
 * Copyright 2006 Kenta Cho. Some rights reserved.
 */
package abagames.dngn {
  import flash.display.SimpleButton;
  import flash.display.Sprite;
  import flash.display.Bitmap;
  import flash.display.BitmapData;
  import flash.events.MouseEvent;
  import flash.geom.Rectangle;

  /**
   * Button to change a barrage pattern.
   */
  public class BarrageButton extends SimpleButton {
    public static var buttonWidth:int = 48;
    public static var buttonHeight:int = 48;
    private var barrage:Barrage;
    private var turretGroup:TurretGroup;

    public function BarrageButton(barrage:Barrage, turretGroup:TurretGroup) {
      this.barrage = barrage;
      this.turretGroup = turretGroup;
      downState = createBarrageSprite(0);
      overState = createBarrageSprite(2);
      upState = hitTestState = createBarrageSprite(1);
      useHandCursor = true;
      addEventListener(MouseEvent.CLICK, onClick);
    }

    public function onClick(evt:MouseEvent):void {
      turretGroup.setBarrage(barrage);
    }

    private function createBarrageSprite(lvl:int):Sprite {
      var sp:Sprite = new Sprite;
      var buffer:BitmapData = new BitmapData(buttonWidth, buttonHeight, false, 0);
      var dummyBuffer:BitmapData = new BitmapData(buttonWidth, buttonHeight, false, 0);
      var screen:Bitmap = new Bitmap(buffer);
      sp.addChild(screen);
      buffer.fillRect(buffer.rect, 0);
      var dw:int = buttonWidth / 6;
      var dh:int = buttonHeight / 6;
      for (var x:int = 0; x < dw; x++) {
        for (var y:int = 0; y < dh; y++) {
          if (!(x == 0 || x == dw - 1 || y ==0 || y == dh - 1)) {
            switch (lvl) {
            case 0:
              buffer.fillRect(new Rectangle(x * 6 + 2, y * 6 + 2, 2, 2), 0x111144);
              break;
            case 1:
            case 2:
              buffer.fillRect(new Rectangle(x * 6 + 1, y * 6 + 1, 3, 3), 0x222266);
              break;
            }
          }
        }
      }
      var bp:BulletPoolImpl = new BulletPoolImpl;
      BulletImpl.scale = 0.18;
      BulletImpl.screenWidth = buttonWidth;
      BulletImpl.screenHeight = buttonHeight;
      var b:BulletImpl;
      b = BulletImpl(bp.addBullet(barrage.getBulletML(), buttonWidth * 0.45, buttonHeight * 0.33, 170, 0));
      for (var i:int = 0; i < 5; i++) {
	for (var j:int = 0; j < 10; j++) {
          bp.run(dummyBuffer);
	  b.setDirection(b.getDirection() - 2);
	  b.setPos(b.getX() + 0.4, b.getY());
	}
        var al:Number = i * 0.1 + 0.1;
        if (i == 4)
          al = 1;
	BulletImpl.rect = new Rectangle(0, 0, 1 + i * 0.75, 1 + i * 0.75);
	BulletImpl.color = Math.floor(0xff * al + 0x22 * (1 - al)) * 0x10000 +
          Math.floor(0xff * al + 0x22 * (1 - al)) * 0x100 +
            Math.floor(0xff * al + 0x66 * (1 - al)) * 0x1;
        bp.run(buffer);
      }
      for (x = 0; x < dw; x++) {
        for (y = 0; y < dh; y++) {
          if (x == 0 || x == dw - 1 || y ==0 || y == dh - 1) {
	    buffer.fillRect(new Rectangle(x * 6, y * 6, 6, 6), 0);
            switch (lvl) {
            case 0:
              buffer.fillRect(new Rectangle(x * 6 + 2, y * 6 + 2, 2, 2), 0x993333);
              break;
            case 1:
              buffer.fillRect(new Rectangle(x * 6 + 1, y * 6 + 1, 4, 4), 0xaa5555);
              break;
            case 2:
              buffer.fillRect(new Rectangle(x * 6 + 1, y * 6 + 1, 4, 4), 0xcc7777);
              break;
            }
          }
        }
      }
      return sp;
    }
  }
}
