/*
 * $Id: Turret.as,v 1.1.1.1 2006/07/17 03:27:32 kenta Exp $
 *
 * Copyright 2006 Kenta Cho. Some rights reserved.
 */
package abagames.dngn {
  import flash.display.BitmapData;
  import flash.geom.Rectangle;
  import abagames.util.bulletml.BulletML;
  import abagames.dngn.BulletPoolImpl;
  import abagames.dngn.TurretGroup;
  import abagames.dngn.Barrage;
  import abagames.dngn.Dots;
  import abagames.dngn.BulletImpl;

  /**
   * Turret that fires bullets.
   */
  public class Turret {
    public static var rect:Rectangle = new Rectangle(0, 0, 5, 5);
    public static var color:uint = 0xff8844;
    public var deg:Number;
    public var degVel:Number, tdegVel:Number;
    public var rad:Number, trad:Number;
    public var x:Number, y:Number;
    public var tx:Number, ty:Number;
    public var fdv:Number;
    public var trDeg:Number, ttrDeg:Number;
    public var posr:Number;
    public var cdeg:Number;
    private var bulletPool:BulletPoolImpl;
    private var fireDeg:Number;
    private var bullet:BulletImpl;
    private var spec:TurretSpec;

    public function Turret(bulletPool:BulletPoolImpl) {
      this.bulletPool = bulletPool;
      deg = 0;
      degVel = tdegVel = 0;
      rad = trad = 0;
      fireDeg = 0;
      fdv = 1;
      trDeg = ttrDeg = 0;
      posr = 0;
      cdeg = 0;
      x = tx = TurretGroup.centerX;
      y = ty = TurretGroup.centerY;
    }

    public function setSpec(spec:TurretSpec):void {
      this.spec = spec;
    }

    public function update(buffer:BitmapData, dots:Dots = null):void {
      buffer.fillRect(rect, color);
      spec.updateTurret(this);
      if (bullet != null) {
	if (!bullet.isEnd()) {
	  bullet.setDirection(getFireDirection360());
	  bullet.setPos(x, y);
	} else {
	  bullet = null;
	}
      }
      rect.x = x - rect.width / 2;
      rect.y = y - rect.height / 2;
      buffer.fillRect(rect, color);
      if (rect.width < 5)
	return;
      if (dots != null)
	dots.pset(rect.x, rect.y, color);
      var fd:Number = getFireDirection();
      rect.x = x - 2 + Math.sin(fd) * 6;
      rect.y = y - 2 - Math.cos(fd) * 6;
      buffer.fillRect(rect, color);
      if (dots != null)
	dots.pset(rect.x, rect.y, color);
      rect.x = x - 2 - Math.sin(fd) * 6;
      rect.y = y - 2 + Math.cos(fd) * 6;
      buffer.fillRect(rect, color);
      if (dots != null)
	dots.pset(rect.x, rect.y, color);
      rect.x = x - 2 + Math.sin(fd + 1.2) * 6;
      rect.y = y - 2 - Math.cos(fd + 1.2) * 6;
      buffer.fillRect(rect, color);
      if (dots != null)
	dots.pset(rect.x, rect.y, color);
      rect.x = x - 2 + Math.sin(fd - 1.2) * 6;
      rect.y = y - 2 - Math.cos(fd - 1.2) * 6;
      buffer.fillRect(rect, color);
      if (dots != null)
	dots.pset(rect.x, rect.y, color);
    }

    public function changeFireDeg(cfd:Number):void {
      fireDeg += cfd * fdv;
    }

    public function fire(barrage:Barrage):void {
      bullet = BulletImpl(bulletPool.addBullet
			  (barrage.getBulletML(), x, y, getFireDirection360(), 0));
    }

    private function getFireDirection():Number {
      return deg + fireDeg + trDeg;
    }

    private function getFireDirection360():Number {
      return getFireDirection() * 180 / Math.PI;
    }
  }
}
