/*
 * $Id: TurretGroup.as,v 1.1.1.1 2006/07/17 03:27:32 kenta Exp $
 *
 * Copyright 2006 Kenta Cho. Some rights reserved.
 */
package abagames.dngn {
  import flash.display.BitmapData;
  import flash.geom.Rectangle;
  import Dngn;

  /**
   * Turret group.
   */
  public class TurretGroup {
    public static var centerX:Number;
    public static var centerY:Number;
    private static var defaultFireInterval:Number = 60;
    private var turrets:Array;
    private var fireInterval:Number;
    private var cnt:int, fireCnt:int, previousFiredCnt:int;
    private var barrage:Barrage;
    private var rect:Rectangle;
    private var spec:TurretSpec;
    private var bullets:BulletPoolImpl;

    public function TurretGroup(bullets:BulletPoolImpl) {
      this.bullets = bullets;
      centerX = Dngn.screenWidth / 2;
      centerY = Dngn.screenHeight / 3;
      cnt = 0;
      previousFiredCnt = 0;
      fireInterval = 16;
      fireCnt = fireInterval;
      rect = new Rectangle(0, 0, 5, 5);
      rect.x = centerX - 2;
      rect.y = centerY - 2;
    }

    public function setSpec(spec:TurretSpec):void {
      this.spec = spec;
      turrets = spec.init(bullets);
    }

    public function setMousePos(x:int, y:int):void {
      spec.setMousePos(turrets, x, y);
    }

    public function setBarrage(barrage:Barrage):void {
      this.barrage = barrage;
    }

    public function update(buffer:BitmapData, dots:Dots = null):void {
      buffer.fillRect(rect, 0xddff77);
      for each (var t:Turret in turrets)
        t.update(buffer, dots);
      cnt++;
      fireCnt--;
      if (fireCnt <= 0) {
        fireCnt = fireInterval;
        fireBullets();
      }
    }

    public function mouseClicked():void {
      fireBullets();
      var itv:Number = cnt - previousFiredCnt;
      if (itv <= defaultFireInterval)
        fireInterval += (itv - fireInterval) * 0.8;
      else
        fireInterval = defaultFireInterval;
      previousFiredCnt = cnt;
      fireCnt = fireInterval;
    }

    private function fireBullets():void {
      if (bullets == null)
        return;
      for each (var t:Turret in turrets)
        t.fire(barrage);
    }

    public function wheelMoved(dlt:int):void {
      for each (var t:Turret in turrets)
        t.changeFireDeg(0.1 * dlt);
    }
  }
}
