/*
 * $Id: SimpleBullet.as,v 1.1.1.1 2006/07/17 03:27:32 kenta Exp $
 *
 * Copyright 2006 Kenta Cho. Some rights reserved.
 */
package abagames.util.bulletml {
  import flash.display.Sprite;
  import abagames.util.bulletml.Bullet;

  /**
   * Simple bullet implementation.
   */
  public class SimpleBullet extends Sprite implements Bullet {
    static public var screenWidth:int = 360;
    static public var screenHeight:int = 480;
    static public var scale:Number = 1;
    static public var rank:Number = 0.5;
    private var bml:BulletML;
    private var bm:BulletsManager;
    private var speed:Number;
    private var acx:Number;
    private var acy:Number;
    private var isVanished:Boolean;

    public function SimpleBullet(bml:BulletML, bm:BulletsManager,
                                 x:Number, y:Number, deg:Number, speed:Number) {
      this.bml = bml;
      this.bm = bm;
      this.x = x;
      this.y = y;
      rotation = deg;
      this.speed = speed;
      acx = acy = 0;
      isVanished = false;
      graphics.beginFill(0xffffff);
      graphics.drawRect(0, 0, 2 * scale, 8 * scale);
      graphics.endFill();
    }

    public function run() {
      bml.run(this, bm);
      x += Math.sin(rotation * Math.PI / 180) * speed * scale;
      y -= Math.cos(rotation * Math.PI / 180) * speed * scale;
      x += acx * scale;
      y += acy * scale;
      if (x < 0 || x >= screenWidth || y < 0 || y >= screenHeight)
        vanish();
    }

    public function isEnd():Boolean {
      return isVanished;
    }

    public function getDirection():Number {
      return rotation;
    }

    public function setDirection(v:Number) {
      rotation = v;
    }

    public function getAimDirection():Number {
      return 180;
    }

    public function getSpeed():Number {
      return speed;
    }

    public function setSpeed(v:Number) {
      speed = v;
    }

    public function getX():Number {
      return x;
    }

    public function getY():Number {
      return y;
    }

    public function getHorizontal():Number {
      return acx;
    }

    public function setHorizontal(v:Number) {
      acx = v;
    }

    public function getVertical():Number {
      return acy;
    }

    public function setVertical(v:Number) {
      acy = v;
    }

    public function vanish() {
      isVanished = true;
    }

    public function getRand():Number {
      return Math.random();
    }

    public function getRank():Number {
      return rank;
    }
  }
}
