/*
 * $Id: SimpleBulletPool.as,v 1.1.1.1 2006/07/17 03:27:32 kenta Exp $
 *
 * Copyright 2006 Kenta Cho. Some rights reserved.
 */
package abagames.util.bulletml {
  import flash.display.Sprite;
  import abagames.util.bulletml.SimpleBullet;
  import abagames.util.bulletml.BulletPool;
  
  /**
   * Simple bullet pool implementation.
   */
  public class SimpleBulletPool implements BulletPool {
    private var bullets:Array = new Array;
    private var screen:Sprite;

    public function SimpleBulletPool(screen:Sprite) {
      this.screen = screen;
    }
 
    public function addBullet(bml:BulletML, x:Number, y:Number,
                              deg:Number, speed:Number):Bullet {
      var b:SimpleBullet = new SimpleBullet(bml, this, x, y, deg, speed);
      screen.addChildAt(b, 0);
      bullets.push(b);
      return b;
    }

    public function run() {
      for each (var b:SimpleBullet in bullets)
        b.run();
      for (var i:int = 0; i < bullets.length; ) {
        var b:SimpleBullet = SimpleBullet(bullets[i]);
        if (b.isEnd()) {
          screen.removeChild(b);
          bullets.splice(i, 1);
        } else {
          i++;
        }
      }
    }

    public function bulletCount():int {
      return bullets.length;
    }
  }
}
